diff --git a/src/backend/access/hash/hashutil.c b/src/backend/access/hash/hashutil.c
new file mode 100644
index 3d66216..85236e2
*** a/src/backend/access/hash/hashutil.c
--- b/src/backend/access/hash/hashutil.c
*************** _hash_checkpage(Relation rel, Buffer buf
*** 217,234 ****
  	}
  }
  
! Datum
! hashoptions(PG_FUNCTION_ARGS)
  {
- 	Datum		reloptions = PG_GETARG_DATUM(0);
- 	bool		validate = PG_GETARG_BOOL(1);
  	bytea	   *result;
  
  	result = default_reloptions(reloptions, validate, RELOPT_KIND_HASH);
  
  	if (result)
! 		PG_RETURN_BYTEA_P(result);
! 	PG_RETURN_NULL();
  }
  
  /*
--- 217,232 ----
  	}
  }
  
! bytea *
! hashoptions(Datum reloptions, bool validate)
  {
  	bytea	   *result;
  
  	result = default_reloptions(reloptions, validate, RELOPT_KIND_HASH);
  
  	if (result)
! 		return result;
! 	return NULL;
  }
  
  /*
diff --git a/src/backend/access/index/indexam.c b/src/backend/access/index/indexam.c
new file mode 100644
index 2b27e73..ebf9313
*** a/src/backend/access/index/indexam.c
--- b/src/backend/access/index/indexam.c
***************
*** 65,70 ****
--- 65,71 ----
  
  #include "postgres.h"
  
+ #include "access/amapi.h"
  #include "access/relscan.h"
  #include "access/transam.h"
  #include "access/xlog.h"
***************
*** 92,140 ****
   * ----------------------------------------------------------------
   */
  #define RELATION_CHECKS \
! ( \
! 	AssertMacro(RelationIsValid(indexRelation)), \
! 	AssertMacro(PointerIsValid(indexRelation->rd_am)), \
! 	AssertMacro(!ReindexIsProcessingIndex(RelationGetRelid(indexRelation))) \
! )
  
  #define SCAN_CHECKS \
- ( \
- 	AssertMacro(IndexScanIsValid(scan)), \
- 	AssertMacro(RelationIsValid(scan->indexRelation)), \
- 	AssertMacro(PointerIsValid(scan->indexRelation->rd_am)) \
- )
- 
- #define GET_REL_PROCEDURE(pname) \
  do { \
! 	procedure = &indexRelation->rd_aminfo->pname; \
! 	if (!OidIsValid(procedure->fn_oid)) \
! 	{ \
! 		RegProcedure	procOid = indexRelation->rd_am->pname; \
! 		if (!RegProcedureIsValid(procOid)) \
! 			elog(ERROR, "invalid %s regproc", CppAsString(pname)); \
! 		fmgr_info_cxt(procOid, procedure, indexRelation->rd_indexcxt); \
! 	} \
! } while(0)
  
! #define GET_UNCACHED_REL_PROCEDURE(pname) \
! do { \
! 	if (!RegProcedureIsValid(indexRelation->rd_am->pname)) \
! 		elog(ERROR, "invalid %s regproc", CppAsString(pname)); \
! 	fmgr_info(indexRelation->rd_am->pname, &procedure); \
! } while(0)
  
! #define GET_SCAN_PROCEDURE(pname) \
! do { \
! 	procedure = &scan->indexRelation->rd_aminfo->pname; \
! 	if (!OidIsValid(procedure->fn_oid)) \
! 	{ \
! 		RegProcedure	procOid = scan->indexRelation->rd_am->pname; \
! 		if (!RegProcedureIsValid(procOid)) \
! 			elog(ERROR, "invalid %s regproc", CppAsString(pname)); \
! 		fmgr_info_cxt(procOid, procedure, scan->indexRelation->rd_indexcxt); \
! 	} \
! } while(0)
  
  static IndexScanDesc index_beginscan_internal(Relation indexRelation,
  						 int nkeys, int norderbys, Snapshot snapshot);
--- 93,124 ----
   * ----------------------------------------------------------------
   */
  #define RELATION_CHECKS \
! do { \
! 	Assert(RelationIsValid(indexRelation)); \
! 	Assert(indexRelation->amroutine); \
! 	Assert(!ReindexIsProcessingIndex(RelationGetRelid(indexRelation))); \
! } while (0)
  
  #define SCAN_CHECKS \
  do { \
! 	Assert(IndexScanIsValid(scan)); \
! 	Assert(RelationIsValid(scan->indexRelation)); \
! 	Assert(scan->indexRelation->amroutine); \
! } while (0)
  
! #define CHECK_PROCEDURE(pname) \
! if (!indexRelation->amroutine->pname) \
! { \
! 	elog(ERROR, "%s is undefined for %s", \
! 		CppAsString(pname), RelationGetRelationName(indexRelation)); \
! } \
  
! #define CHECK_SCAN_PROCEDURE(pname) \
! if (!scan->indexRelation->amroutine->pname) \
! { \
! 	elog(ERROR, "%s is undefined for %s", \
! 		CppAsString(pname), RelationGetRelationName(scan->indexRelation)); \
! } \
  
  static IndexScanDesc index_beginscan_internal(Relation indexRelation,
  						 int nkeys, int norderbys, Snapshot snapshot);
*************** index_insert(Relation indexRelation,
*** 210,235 ****
  			 Relation heapRelation,
  			 IndexUniqueCheck checkUnique)
  {
- 	FmgrInfo   *procedure;
- 
  	RELATION_CHECKS;
! 	GET_REL_PROCEDURE(aminsert);
  
! 	if (!(indexRelation->rd_am->ampredlocks))
  		CheckForSerializableConflictIn(indexRelation,
  									   (HeapTuple) NULL,
  									   InvalidBuffer);
  
! 	/*
! 	 * have the am's insert proc do all the work.
! 	 */
! 	return DatumGetBool(FunctionCall6(procedure,
! 									  PointerGetDatum(indexRelation),
! 									  PointerGetDatum(values),
! 									  PointerGetDatum(isnull),
! 									  PointerGetDatum(heap_t_ctid),
! 									  PointerGetDatum(heapRelation),
! 									  Int32GetDatum((int32) checkUnique)));
  }
  
  /*
--- 194,210 ----
  			 Relation heapRelation,
  			 IndexUniqueCheck checkUnique)
  {
  	RELATION_CHECKS;
! 	CHECK_PROCEDURE(aminsert);
  
! 	if (!(indexRelation->amroutine->ampredlocks))
  		CheckForSerializableConflictIn(indexRelation,
  									   (HeapTuple) NULL,
  									   InvalidBuffer);
  
! 	return indexRelation->amroutine->aminsert(indexRelation, values, isnull,
! 											  heap_t_ctid, heapRelation,
! 											  checkUnique);
  }
  
  /*
*************** index_beginscan_internal(Relation indexR
*** 289,300 ****
  						 int nkeys, int norderbys, Snapshot snapshot)
  {
  	IndexScanDesc scan;
- 	FmgrInfo   *procedure;
  
  	RELATION_CHECKS;
! 	GET_REL_PROCEDURE(ambeginscan);
  
! 	if (!(indexRelation->rd_am->ampredlocks))
  		PredicateLockRelation(indexRelation, snapshot);
  
  	/*
--- 264,274 ----
  						 int nkeys, int norderbys, Snapshot snapshot)
  {
  	IndexScanDesc scan;
  
  	RELATION_CHECKS;
! 	CHECK_PROCEDURE(ambeginscan);
  
! 	if (!(indexRelation->amroutine->ampredlocks))
  		PredicateLockRelation(indexRelation, snapshot);
  
  	/*
*************** index_beginscan_internal(Relation indexR
*** 305,315 ****
  	/*
  	 * Tell the AM to open a scan.
  	 */
! 	scan = (IndexScanDesc)
! 		DatumGetPointer(FunctionCall3(procedure,
! 									  PointerGetDatum(indexRelation),
! 									  Int32GetDatum(nkeys),
! 									  Int32GetDatum(norderbys)));
  
  	return scan;
  }
--- 279,286 ----
  	/*
  	 * Tell the AM to open a scan.
  	 */
! 	scan = indexRelation->amroutine->ambeginscan(indexRelation, nkeys,
! 												 norderbys);
  
  	return scan;
  }
*************** index_rescan(IndexScanDesc scan,
*** 331,340 ****
  			 ScanKey keys, int nkeys,
  			 ScanKey orderbys, int norderbys)
  {
- 	FmgrInfo   *procedure;
- 
  	SCAN_CHECKS;
! 	GET_SCAN_PROCEDURE(amrescan);
  
  	Assert(nkeys == scan->numberOfKeys);
  	Assert(norderbys == scan->numberOfOrderBys);
--- 302,309 ----
  			 ScanKey keys, int nkeys,
  			 ScanKey orderbys, int norderbys)
  {
  	SCAN_CHECKS;
! 	CHECK_SCAN_PROCEDURE(amrescan);
  
  	Assert(nkeys == scan->numberOfKeys);
  	Assert(norderbys == scan->numberOfOrderBys);
*************** index_rescan(IndexScanDesc scan,
*** 350,361 ****
  
  	scan->kill_prior_tuple = false;		/* for safety */
  
! 	FunctionCall5(procedure,
! 				  PointerGetDatum(scan),
! 				  PointerGetDatum(keys),
! 				  Int32GetDatum(nkeys),
! 				  PointerGetDatum(orderbys),
! 				  Int32GetDatum(norderbys));
  }
  
  /* ----------------
--- 319,326 ----
  
  	scan->kill_prior_tuple = false;		/* for safety */
  
! 	scan->indexRelation->amroutine->amrescan(scan, keys, nkeys,
! 											 orderbys, norderbys);
  }
  
  /* ----------------
*************** index_rescan(IndexScanDesc scan,
*** 365,374 ****
  void
  index_endscan(IndexScanDesc scan)
  {
- 	FmgrInfo   *procedure;
- 
  	SCAN_CHECKS;
! 	GET_SCAN_PROCEDURE(amendscan);
  
  	/* Release any held pin on a heap page */
  	if (BufferIsValid(scan->xs_cbuf))
--- 330,337 ----
  void
  index_endscan(IndexScanDesc scan)
  {
  	SCAN_CHECKS;
! 	CHECK_SCAN_PROCEDURE(amendscan);
  
  	/* Release any held pin on a heap page */
  	if (BufferIsValid(scan->xs_cbuf))
*************** index_endscan(IndexScanDesc scan)
*** 378,384 ****
  	}
  
  	/* End the AM's scan */
! 	FunctionCall1(procedure, PointerGetDatum(scan));
  
  	/* Release index refcount acquired by index_beginscan */
  	RelationDecrementReferenceCount(scan->indexRelation);
--- 341,347 ----
  	}
  
  	/* End the AM's scan */
! 	scan->indexRelation->amroutine->amendscan(scan);
  
  	/* Release index refcount acquired by index_beginscan */
  	RelationDecrementReferenceCount(scan->indexRelation);
*************** index_endscan(IndexScanDesc scan)
*** 394,405 ****
  void
  index_markpos(IndexScanDesc scan)
  {
- 	FmgrInfo   *procedure;
- 
  	SCAN_CHECKS;
! 	GET_SCAN_PROCEDURE(ammarkpos);
  
! 	FunctionCall1(procedure, PointerGetDatum(scan));
  }
  
  /* ----------------
--- 357,366 ----
  void
  index_markpos(IndexScanDesc scan)
  {
  	SCAN_CHECKS;
! 	CHECK_SCAN_PROCEDURE(ammarkpos);
  
! 	scan->indexRelation->amroutine->ammarkpos(scan);
  }
  
  /* ----------------
*************** index_markpos(IndexScanDesc scan)
*** 421,438 ****
  void
  index_restrpos(IndexScanDesc scan)
  {
- 	FmgrInfo   *procedure;
- 
  	Assert(IsMVCCSnapshot(scan->xs_snapshot));
  
  	SCAN_CHECKS;
! 	GET_SCAN_PROCEDURE(amrestrpos);
  
  	scan->xs_continue_hot = false;
  
  	scan->kill_prior_tuple = false;		/* for safety */
  
! 	FunctionCall1(procedure, PointerGetDatum(scan));
  }
  
  /* ----------------
--- 382,397 ----
  void
  index_restrpos(IndexScanDesc scan)
  {
  	Assert(IsMVCCSnapshot(scan->xs_snapshot));
  
  	SCAN_CHECKS;
! 	CHECK_SCAN_PROCEDURE(amrestrpos);
  
  	scan->xs_continue_hot = false;
  
  	scan->kill_prior_tuple = false;		/* for safety */
  
! 	scan->indexRelation->amroutine->amrestrpos(scan);
  }
  
  /* ----------------
*************** index_restrpos(IndexScanDesc scan)
*** 445,455 ****
  ItemPointer
  index_getnext_tid(IndexScanDesc scan, ScanDirection direction)
  {
- 	FmgrInfo   *procedure;
  	bool		found;
  
  	SCAN_CHECKS;
! 	GET_SCAN_PROCEDURE(amgettuple);
  
  	Assert(TransactionIdIsValid(RecentGlobalXmin));
  
--- 404,413 ----
  ItemPointer
  index_getnext_tid(IndexScanDesc scan, ScanDirection direction)
  {
  	bool		found;
  
  	SCAN_CHECKS;
! 	CHECK_SCAN_PROCEDURE(amgettuple);
  
  	Assert(TransactionIdIsValid(RecentGlobalXmin));
  
*************** index_getnext_tid(IndexScanDesc scan, Sc
*** 459,467 ****
  	 * scan->xs_recheck and possibly scan->xs_itup, though we pay no attention
  	 * to those fields here.
  	 */
! 	found = DatumGetBool(FunctionCall2(procedure,
! 									   PointerGetDatum(scan),
! 									   Int32GetDatum(direction)));
  
  	/* Reset kill flag immediately for safety */
  	scan->kill_prior_tuple = false;
--- 417,423 ----
  	 * scan->xs_recheck and possibly scan->xs_itup, though we pay no attention
  	 * to those fields here.
  	 */
! 	found = scan->indexRelation->amroutine->amgettuple(scan, direction);
  
  	/* Reset kill flag immediately for safety */
  	scan->kill_prior_tuple = false;
*************** index_getnext(IndexScanDesc scan, ScanDi
*** 635,646 ****
  int64
  index_getbitmap(IndexScanDesc scan, TIDBitmap *bitmap)
  {
- 	FmgrInfo   *procedure;
  	int64		ntids;
  	Datum		d;
  
  	SCAN_CHECKS;
! 	GET_SCAN_PROCEDURE(amgetbitmap);
  
  	/* just make sure this is false... */
  	scan->kill_prior_tuple = false;
--- 591,601 ----
  int64
  index_getbitmap(IndexScanDesc scan, TIDBitmap *bitmap)
  {
  	int64		ntids;
  	Datum		d;
  
  	SCAN_CHECKS;
! 	CHECK_SCAN_PROCEDURE(amgetbitmap);
  
  	/* just make sure this is false... */
  	scan->kill_prior_tuple = false;
*************** index_getbitmap(IndexScanDesc scan, TIDB
*** 648,656 ****
  	/*
  	 * have the am's getbitmap proc do all the work.
  	 */
! 	d = FunctionCall2(procedure,
! 					  PointerGetDatum(scan),
! 					  PointerGetDatum(bitmap));
  
  	ntids = DatumGetInt64(d);
  
--- 603,609 ----
  	/*
  	 * have the am's getbitmap proc do all the work.
  	 */
! 	d = scan->indexRelation->amroutine->amgetbitmap(scan, bitmap);
  
  	ntids = DatumGetInt64(d);
  
*************** index_bulk_delete(IndexVacuumInfo *info,
*** 680,699 ****
  				  void *callback_state)
  {
  	Relation	indexRelation = info->index;
- 	FmgrInfo	procedure;
- 	IndexBulkDeleteResult *result;
  
  	RELATION_CHECKS;
! 	GET_UNCACHED_REL_PROCEDURE(ambulkdelete);
! 
! 	result = (IndexBulkDeleteResult *)
! 		DatumGetPointer(FunctionCall4(&procedure,
! 									  PointerGetDatum(info),
! 									  PointerGetDatum(stats),
! 									  PointerGetDatum((Pointer) callback),
! 									  PointerGetDatum(callback_state)));
  
! 	return result;
  }
  
  /* ----------------
--- 633,644 ----
  				  void *callback_state)
  {
  	Relation	indexRelation = info->index;
  
  	RELATION_CHECKS;
! 	CHECK_PROCEDURE(ambulkdelete);
  
! 	return indexRelation->amroutine->ambulkdelete(info, stats,
! 												  callback, callback_state);
  }
  
  /* ----------------
*************** index_vacuum_cleanup(IndexVacuumInfo *in
*** 707,724 ****
  					 IndexBulkDeleteResult *stats)
  {
  	Relation	indexRelation = info->index;
- 	FmgrInfo	procedure;
- 	IndexBulkDeleteResult *result;
  
  	RELATION_CHECKS;
! 	GET_UNCACHED_REL_PROCEDURE(amvacuumcleanup);
! 
! 	result = (IndexBulkDeleteResult *)
! 		DatumGetPointer(FunctionCall2(&procedure,
! 									  PointerGetDatum(info),
! 									  PointerGetDatum(stats)));
  
! 	return result;
  }
  
  /* ----------------
--- 652,662 ----
  					 IndexBulkDeleteResult *stats)
  {
  	Relation	indexRelation = info->index;
  
  	RELATION_CHECKS;
! 	CHECK_PROCEDURE(amvacuumcleanup);
  
! 	return indexRelation->amroutine->amvacuumcleanup(info, stats);
  }
  
  /* ----------------
*************** index_vacuum_cleanup(IndexVacuumInfo *in
*** 731,749 ****
  bool
  index_can_return(Relation indexRelation, int attno)
  {
- 	FmgrInfo   *procedure;
- 
  	RELATION_CHECKS;
  
  	/* amcanreturn is optional; assume FALSE if not provided by AM */
! 	if (!RegProcedureIsValid(indexRelation->rd_am->amcanreturn))
  		return false;
  
! 	GET_REL_PROCEDURE(amcanreturn);
! 
! 	return DatumGetBool(FunctionCall2(procedure,
! 									  PointerGetDatum(indexRelation),
! 									  Int32GetDatum(attno)));
  }
  
  /* ----------------
--- 669,681 ----
  bool
  index_can_return(Relation indexRelation, int attno)
  {
  	RELATION_CHECKS;
  
  	/* amcanreturn is optional; assume FALSE if not provided by AM */
! 	if (!indexRelation->amroutine->amcanreturn)
  		return false;
  
! 	return indexRelation->amroutine->amcanreturn(indexRelation, attno);
  }
  
  /* ----------------
*************** index_getprocid(Relation irel,
*** 781,787 ****
  	int			nproc;
  	int			procindex;
  
! 	nproc = irel->rd_am->amsupport;
  
  	Assert(procnum > 0 && procnum <= (uint16) nproc);
  
--- 713,719 ----
  	int			nproc;
  	int			procindex;
  
! 	nproc = irel->amroutine->amsupport;
  
  	Assert(procnum > 0 && procnum <= (uint16) nproc);
  
*************** index_getprocinfo(Relation irel,
*** 815,821 ****
  	int			nproc;
  	int			procindex;
  
! 	nproc = irel->rd_am->amsupport;
  
  	Assert(procnum > 0 && procnum <= (uint16) nproc);
  
--- 747,753 ----
  	int			nproc;
  	int			procindex;
  
! 	nproc = irel->amroutine->amsupport;
  
  	Assert(procnum > 0 && procnum <= (uint16) nproc);
  
diff --git a/src/backend/access/nbtree/nbtree.c b/src/backend/access/nbtree/nbtree.c
new file mode 100644
index cf4a6dc..ee623ae
*** a/src/backend/access/nbtree/nbtree.c
--- b/src/backend/access/nbtree/nbtree.c
*************** static void btvacuumpage(BTVacState *vst
*** 76,89 ****
  
  
  /*
!  *	btbuild() -- build a new btree index.
   */
  Datum
! btbuild(PG_FUNCTION_ARGS)
  {
- 	Relation	heap = (Relation) PG_GETARG_POINTER(0);
- 	Relation	index = (Relation) PG_GETARG_POINTER(1);
- 	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
  	IndexBuildResult *result;
  	double		reltuples;
  	BTBuildState buildstate;
--- 76,182 ----
  
  
  /*
!  * Btree handler function: return IndexAmRoutine with access method parameters
!  * and callbacks.
   */
  Datum
! bthandler(PG_FUNCTION_ARGS)
! {
! 	IndexAmRoutine *amroutine = makeNode(IndexAmRoutine);
! 
! 	amroutine->amstrategies = 5;
! 	amroutine->amsupport = 2;
! 	amroutine->amcanorder = true;
! 	amroutine->amcanorderbyop = false;
! 	amroutine->amcanbackward = true;
! 	amroutine->amcanunique = true;
! 	amroutine->amcanmulticol = true;
! 	amroutine->amoptionalkey = true;
! 	amroutine->amsearcharray = true;
! 	amroutine->amsearchnulls = true;
! 	amroutine->amstorage = false;
! 	amroutine->amclusterable = true;
! 	amroutine->ampredlocks = true;
! 	amroutine->amkeytype = 0;
! 
! 	amroutine->aminsert = btinsert;
! 	amroutine->ambeginscan = btbeginscan;
! 	amroutine->amgettuple = btgettuple;
! 	amroutine->amgetbitmap = btgetbitmap;
! 	amroutine->amrescan = btrescan;
! 	amroutine->amendscan = btendscan;
! 	amroutine->ammarkpos = btmarkpos;
! 	amroutine->amrestrpos = btrestrpos;
! 	amroutine->ambuild = btbuild;
! 	amroutine->ambuildempty = btbuildempty;
! 	amroutine->ambulkdelete = btbulkdelete;
! 	amroutine->amvacuumcleanup = btvacuumcleanup;
! 	amroutine->amcanreturn = btcanreturn;
! 	amroutine->amcostestimate = btcostestimate;
! 	amroutine->amoptions = btoptions;
! 	amroutine->amvalidate = btvalidate;
! 
! 	PG_RETURN_POINTER(amroutine);
! }
! 
! void
! btvalidate(OpClassInfo *opclass)
! {
! 	ListCell   *l;
! 
! 	foreach(l, opclass->procedures)
! 	{
! 		OpFamilyMember *proc = (OpFamilyMember *) lfirst(l);
! 
! 		if (proc->number != BTORDER_PROC &&
! 			proc->number != BTSORTSUPPORT_PROC)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
! 					 errmsg("invalid support number for btree: %u",
! 							proc->number)));
! 	}
! 
! 	foreach(l, opclass->operators)
! 	{
! 		OpFamilyMember *opr = (OpFamilyMember *) lfirst(l);
! 		bool			found = false;
! 		ListCell	   *ll;
! 
! 		if (OidIsValid(opr->sortfamily))
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
! 					 errmsg("btree doesn't support ORDER BY operators")));
! 
! 		if (opr->number < 1 || opr->number > BTMaxStrategyNumber)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
! 					 errmsg("invalid strategy number for btree: %u",
! 							opr->number)));
! 
! 		foreach(ll, opclass->procedures)
! 		{
! 			OpFamilyMember *proc = (OpFamilyMember *) lfirst(ll);
! 
! 			if (proc->number == BTORDER_PROC &&
! 				proc->lefttype == opr->lefttype &&
! 				proc->righttype == opr->righttype)
! 				found = true;
! 		}
! 
! 		if (!found)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
! 					 errmsg("no ordering procedure found for operator: %u",
! 							opr->object)));
! 	}
! }
! 
! /*
!  *	btbuild() -- build a new btree index.
!  */
! IndexBuildResult *
! btbuild(Relation heap, Relation index, IndexInfo *indexInfo)
  {
  	IndexBuildResult *result;
  	double		reltuples;
  	BTBuildState buildstate;
*************** btbuild(PG_FUNCTION_ARGS)
*** 155,161 ****
  	result->heap_tuples = reltuples;
  	result->index_tuples = buildstate.indtuples;
  
! 	PG_RETURN_POINTER(result);
  }
  
  /*
--- 248,254 ----
  	result->heap_tuples = reltuples;
  	result->index_tuples = buildstate.indtuples;
  
! 	return result;
  }
  
  /*
*************** btbuildCallback(Relation index,
*** 190,200 ****
  /*
   *	btbuildempty() -- build an empty btree index in the initialization fork
   */
! Datum
! btbuildempty(PG_FUNCTION_ARGS)
  {
! 	Relation	index = (Relation) PG_GETARG_POINTER(0);
! 	Page		metapage;
  
  	/* Construct metapage. */
  	metapage = (Page) palloc(BLCKSZ);
--- 283,292 ----
  /*
   *	btbuildempty() -- build an empty btree index in the initialization fork
   */
! void
! btbuildempty(Relation index)
  {
! 	Page	metapage;
  
  	/* Construct metapage. */
  	metapage = (Page) palloc(BLCKSZ);
*************** btbuildempty(PG_FUNCTION_ARGS)
*** 214,221 ****
  	 * checkpoint may have moved the redo pointer past our xlog record.
  	 */
  	smgrimmedsync(index->rd_smgr, INIT_FORKNUM);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
--- 306,311 ----
*************** btbuildempty(PG_FUNCTION_ARGS)
*** 224,238 ****
   *		Descend the tree recursively, find the appropriate location for our
   *		new tuple, and put it there.
   */
! Datum
! btinsert(PG_FUNCTION_ARGS)
  {
- 	Relation	rel = (Relation) PG_GETARG_POINTER(0);
- 	Datum	   *values = (Datum *) PG_GETARG_POINTER(1);
- 	bool	   *isnull = (bool *) PG_GETARG_POINTER(2);
- 	ItemPointer ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
- 	Relation	heapRel = (Relation) PG_GETARG_POINTER(4);
- 	IndexUniqueCheck checkUnique = (IndexUniqueCheck) PG_GETARG_INT32(5);
  	bool		result;
  	IndexTuple	itup;
  
--- 314,324 ----
   *		Descend the tree recursively, find the appropriate location for our
   *		new tuple, and put it there.
   */
! bool
! btinsert(Relation rel, Datum *values, bool *isnull,
! 		 ItemPointer ht_ctid, Relation heapRel,
! 		 IndexUniqueCheck checkUnique)
  {
  	bool		result;
  	IndexTuple	itup;
  
*************** btinsert(PG_FUNCTION_ARGS)
*** 244,260 ****
  
  	pfree(itup);
  
! 	PG_RETURN_BOOL(result);
  }
  
  /*
   *	btgettuple() -- Get the next tuple in the scan.
   */
! Datum
! btgettuple(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanDirection dir = (ScanDirection) PG_GETARG_INT32(1);
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  	bool		res;
  
--- 330,344 ----
  
  	pfree(itup);
  
! 	return result;
  }
  
  /*
   *	btgettuple() -- Get the next tuple in the scan.
   */
! bool
! btgettuple(IndexScanDesc scan, ScanDirection dir)
  {
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  	bool		res;
  
*************** btgettuple(PG_FUNCTION_ARGS)
*** 270,276 ****
  	{
  		/* punt if we have any unsatisfiable array keys */
  		if (so->numArrayKeys < 0)
! 			PG_RETURN_BOOL(false);
  
  		_bt_start_array_keys(scan, dir);
  	}
--- 354,360 ----
  	{
  		/* punt if we have any unsatisfiable array keys */
  		if (so->numArrayKeys < 0)
! 			return false;
  
  		_bt_start_array_keys(scan, dir);
  	}
*************** btgettuple(PG_FUNCTION_ARGS)
*** 320,336 ****
  		/* ... otherwise see if we have more array keys to deal with */
  	} while (so->numArrayKeys && _bt_advance_array_keys(scan, dir));
  
! 	PG_RETURN_BOOL(res);
  }
  
  /*
   * btgetbitmap() -- gets all matching tuples, and adds them to a bitmap
   */
! Datum
! btgetbitmap(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	TIDBitmap  *tbm = (TIDBitmap *) PG_GETARG_POINTER(1);
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  	int64		ntids = 0;
  	ItemPointer heapTid;
--- 404,418 ----
  		/* ... otherwise see if we have more array keys to deal with */
  	} while (so->numArrayKeys && _bt_advance_array_keys(scan, dir));
  
! 	return res;
  }
  
  /*
   * btgetbitmap() -- gets all matching tuples, and adds them to a bitmap
   */
! int64
! btgetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
  {
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  	int64		ntids = 0;
  	ItemPointer heapTid;
*************** btgetbitmap(PG_FUNCTION_ARGS)
*** 342,348 ****
  	{
  		/* punt if we have any unsatisfiable array keys */
  		if (so->numArrayKeys < 0)
! 			PG_RETURN_INT64(ntids);
  
  		_bt_start_array_keys(scan, ForwardScanDirection);
  	}
--- 424,430 ----
  	{
  		/* punt if we have any unsatisfiable array keys */
  		if (so->numArrayKeys < 0)
! 			return ntids;
  
  		_bt_start_array_keys(scan, ForwardScanDirection);
  	}
*************** btgetbitmap(PG_FUNCTION_ARGS)
*** 380,397 ****
  		/* Now see if we have more array keys to deal with */
  	} while (so->numArrayKeys && _bt_advance_array_keys(scan, ForwardScanDirection));
  
! 	PG_RETURN_INT64(ntids);
  }
  
  /*
   *	btbeginscan() -- start a scan on a btree index
   */
! Datum
! btbeginscan(PG_FUNCTION_ARGS)
  {
- 	Relation	rel = (Relation) PG_GETARG_POINTER(0);
- 	int			nkeys = PG_GETARG_INT32(1);
- 	int			norderbys = PG_GETARG_INT32(2);
  	IndexScanDesc scan;
  	BTScanOpaque so;
  
--- 462,476 ----
  		/* Now see if we have more array keys to deal with */
  	} while (so->numArrayKeys && _bt_advance_array_keys(scan, ForwardScanDirection));
  
! 	return ntids;
  }
  
  /*
   *	btbeginscan() -- start a scan on a btree index
   */
! IndexScanDesc
! btbeginscan(Relation rel, int nkeys, int norderbys)
  {
  	IndexScanDesc scan;
  	BTScanOpaque so;
  
*************** btbeginscan(PG_FUNCTION_ARGS)
*** 429,447 ****
  
  	scan->opaque = so;
  
! 	PG_RETURN_POINTER(scan);
  }
  
  /*
   *	btrescan() -- rescan an index relation
   */
! Datum
! btrescan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(1);
- 
- 	/* remaining arguments are ignored */
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* we aren't holding any read locks, but gotta drop the pins */
--- 508,523 ----
  
  	scan->opaque = so;
  
! 	return scan;
  }
  
  /*
   *	btrescan() -- rescan an index relation
   */
! void
! btrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 		 ScanKey orderbys, int norderbys)
  {
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* we aren't holding any read locks, but gotta drop the pins */
*************** btrescan(PG_FUNCTION_ARGS)
*** 492,508 ****
  
  	/* If any keys are SK_SEARCHARRAY type, set up array-key info */
  	_bt_preprocess_array_keys(scan);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   *	btendscan() -- close down a scan
   */
! Datum
! btendscan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* we aren't holding any read locks, but gotta drop the pins */
--- 568,581 ----
  
  	/* If any keys are SK_SEARCHARRAY type, set up array-key info */
  	_bt_preprocess_array_keys(scan);
  }
  
  /*
   *	btendscan() -- close down a scan
   */
! void
! btendscan(IndexScanDesc scan)
  {
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* we aren't holding any read locks, but gotta drop the pins */
*************** btendscan(PG_FUNCTION_ARGS)
*** 531,547 ****
  		pfree(so->currTuples);
  	/* so->markTuples should not be pfree'd, see btrescan */
  	pfree(so);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   *	btmarkpos() -- save current scan position
   */
! Datum
! btmarkpos(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* There may be an old mark with a pin (but no lock). */
--- 604,617 ----
  		pfree(so->currTuples);
  	/* so->markTuples should not be pfree'd, see btrescan */
  	pfree(so);
  }
  
  /*
   *	btmarkpos() -- save current scan position
   */
! void
! btmarkpos(IndexScanDesc scan)
  {
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* There may be an old mark with a pin (but no lock). */
*************** btmarkpos(PG_FUNCTION_ARGS)
*** 564,580 ****
  	/* Also record the current positions of any array keys */
  	if (so->numArrayKeys)
  		_bt_mark_array_keys(scan);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   *	btrestrpos() -- restore scan to last saved position
   */
! Datum
! btrestrpos(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* Restore the marked positions of any array keys */
--- 634,647 ----
  	/* Also record the current positions of any array keys */
  	if (so->numArrayKeys)
  		_bt_mark_array_keys(scan);
  }
  
  /*
   *	btrestrpos() -- restore scan to last saved position
   */
! void
! btrestrpos(IndexScanDesc scan)
  {
  	BTScanOpaque so = (BTScanOpaque) scan->opaque;
  
  	/* Restore the marked positions of any array keys */
*************** btrestrpos(PG_FUNCTION_ARGS)
*** 642,649 ****
  		else
  			BTScanPosInvalidate(so->currPos);
  	}
- 
- 	PG_RETURN_VOID();
  }
  
  /*
--- 709,714 ----
*************** btrestrpos(PG_FUNCTION_ARGS)
*** 653,665 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! btbulkdelete(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *volatile stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 	IndexBulkDeleteCallback callback = (IndexBulkDeleteCallback) PG_GETARG_POINTER(2);
- 	void	   *callback_state = (void *) PG_GETARG_POINTER(3);
  	Relation	rel = info->index;
  	BTCycleId	cycleid;
  
--- 718,727 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! btbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
! 			 IndexBulkDeleteCallback callback, void *callback_state)
  {
  	Relation	rel = info->index;
  	BTCycleId	cycleid;
  
*************** btbulkdelete(PG_FUNCTION_ARGS)
*** 678,684 ****
  	PG_END_ENSURE_ERROR_CLEANUP(_bt_end_vacuum_callback, PointerGetDatum(rel));
  	_bt_end_vacuum(rel);
  
! 	PG_RETURN_POINTER(stats);
  }
  
  /*
--- 740,746 ----
  	PG_END_ENSURE_ERROR_CLEANUP(_bt_end_vacuum_callback, PointerGetDatum(rel));
  	_bt_end_vacuum(rel);
  
! 	return stats;
  }
  
  /*
*************** btbulkdelete(PG_FUNCTION_ARGS)
*** 686,700 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! btvacuumcleanup(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		PG_RETURN_POINTER(stats);
  
  	/*
  	 * If btbulkdelete was called, we need not do anything, just return the
--- 748,759 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! btvacuumcleanup(IndexVacuumInfo *info, IndexBulkDeleteResult *stats)
  {
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		return stats;
  
  	/*
  	 * If btbulkdelete was called, we need not do anything, just return the
*************** btvacuumcleanup(PG_FUNCTION_ARGS)
*** 726,732 ****
  			stats->num_index_tuples = info->num_heap_tuples;
  	}
  
! 	PG_RETURN_POINTER(stats);
  }
  
  /*
--- 785,791 ----
  			stats->num_index_tuples = info->num_heap_tuples;
  	}
  
! 	return stats;
  }
  
  /*
*************** restart:
*** 1127,1134 ****
   *
   * btrees always do, so this is trivial.
   */
! Datum
! btcanreturn(PG_FUNCTION_ARGS)
  {
  	PG_RETURN_BOOL(true);
  }
--- 1186,1193 ----
   *
   * btrees always do, so this is trivial.
   */
! bool
! btcanreturn(Relation index, int attno)
  {
  	PG_RETURN_BOOL(true);
  }
diff --git a/src/backend/access/nbtree/nbtutils.c b/src/backend/access/nbtree/nbtutils.c
new file mode 100644
index 91331ba..2fec62d
*** a/src/backend/access/nbtree/nbtutils.c
--- b/src/backend/access/nbtree/nbtutils.c
*************** BTreeShmemInit(void)
*** 2058,2072 ****
  		Assert(found);
  }
  
! Datum
! btoptions(PG_FUNCTION_ARGS)
  {
- 	Datum		reloptions = PG_GETARG_DATUM(0);
- 	bool		validate = PG_GETARG_BOOL(1);
  	bytea	   *result;
  
  	result = default_reloptions(reloptions, validate, RELOPT_KIND_BTREE);
  	if (result)
! 		PG_RETURN_BYTEA_P(result);
! 	PG_RETURN_NULL();
  }
--- 2058,2070 ----
  		Assert(found);
  }
  
! bytea *
! btoptions(Datum reloptions, bool validate)
  {
  	bytea	   *result;
  
  	result = default_reloptions(reloptions, validate, RELOPT_KIND_BTREE);
  	if (result)
! 		return result;
! 	return NULL;
  }
